flask_book/models/entries.py
from flask_book import db
from datetime import datetime

class Entry(db.Model):
    __tablename__ = 'entries'
    id = db.Column(db.Integer, primary_key=True)
    title = db.Column(db.Text, unique=True)
    description = db.Column(db.Text)
    publisher = db.Column(db.Text)
    publisheddate = db.Column(db.Text)
    identifier10 = db.Column(db.Text)
    identifier13 = db.Column(db.Text)
    thumbnail = db.Column(db.Text)
    previewlink = db.Column(db.Text)
    tanto = db.Column(db.Text)
    hokan = db.Column(db.Text)
    memo = db.Column(db.Text)
    created_at = db.Column(db.DateTime)

    def __init__(self, title=None, description=None, publisher=None, publisheddate=None, identifier10=None, identifier13=None, thumbnail=None, previewlink=None, tanto=None, hokan=None, memo=None):
        self.title = title
        self.description = description
        self.publisher = publisher
        self.publisheddate = publisheddate
        self.identifier10 = identifier10
        self.identifier13 = identifier13
        self.thumbnail = thumbnail
        self.previewlink = previewlink
        self.tanto = tanto
        self.hokan = hokan
        self.memo = memo
        self.created_at = datetime.utcnow()

    def __repr__(self):
        return '<Entry id:{} title:{} description:{} publisher:{} publisheddate:{} identifier10:{} identifier13:{} thumbnail:{} previewlink:{} tanto:{} hokan:{} memo:{}>'.format(self.id, self.title, self.description, self.publisher, self.publisheddate, self.identifier10, self.identifier13, self.thumbnail, self.previewlink, self.tanto, self.hokan, self.memo)

flask_book/__init__.py
from flask import Flask
from flask_sqlalchemy import SQLAlchemy

app = Flask(__name__)
app.config.from_object('flask_book.config')

db = SQLAlchemy(app)

from flask_book.views.entries import entry

app.register_blueprint(entry, url_prefix='/list')

from flask_book.views import views

flask_book/views/entries.py
from flask import request, redirect, url_for, render_template, flash, session
from flask_book import app
from flask_book import db
from flask_book.models.entries import Entry
from flask_book.views.views import login_required
from flask import Blueprint
from flask_paginate import Pagination, get_page_parameter
import sys
import datetime
import requests
import json
from sqlalchemy import or_

entry = Blueprint('entry', __name__)

@entry.route('/')
@entry.route('/', defaults={'page': 1})
@entry.route('/<int:page>')
def show_entries():
    entries=Entry.query.order_by(Entry.id.desc()).all()
    return render_template('entries/index.html', entries=entries)


@entry.route('/', methods=['POST'])
# @login_required
def search_entries():
    try:
        searchword = request.form['searchword']
    except:
        searchword = ""

    # per_page = 20
    # search = False
    # q = request.args.get('q')
    # if q:
    #     search = True
    # name = request.args.get('name', '')
    # page = request.args.get(get_page_parameter(), type=int, default=1)
    # p = User.query.filter((User.name.like('%' + name + '%')) | (not name)).order_by(User.username.asc()).paginate(page,perpage)
    # entries = Entry.query.filter((Entry.title.like('%' + searchword + '%'))).order_by(Entry.id.desc())
    entries = Entry.query.filter(or_(
        (Entry.title.like('%' + searchword + '%')),
        (Entry.description.like('%' + searchword + '%')),
        (Entry.publisher.like('%' + searchword + '%')),
        (Entry.publisheddate.like('%' + searchword + '%')),
        (Entry.identifier10.like('%' + searchword + '%')),
        (Entry.identifier13.like('%' + searchword + '%')),
        (Entry.tanto.like('%' + searchword + '%')),
        (Entry.hokan.like('%' + searchword + '%')),
        (Entry.memo.like('%' + searchword + '%')),
    )).order_by(Entry.id.desc())
    # return render_template( 'user.html', pagination=p,name=name)
    # pagination = Pagination(page=page, total=3, search=search, record_name='entries')
    # return render_template('entries/index.html', entries=entries, pagination=pagination)
    return render_template('entries/index.html', entries=entries)
    # pagination = Pagination(page=page, total=entries.count(), search=search, record_name='entries', css_framework='foundation', **kwargs)



@entry.route('/alllist')
@login_required
def show_alllist():
    entries = Entry.query.all()
    return render_template('entries/alllist.html', entries=entries)


@entry.route('/entries', methods=['POST'])
@login_required
def add_entry():
    try:
        entry = Entry(
                title=request.form['title'],
                description=request.form['description'],
                publisher=request.form['publisher'],
                publisheddate=request.form['publisheddate'],
                identifier10=request.form['identifier10'],
                identifier13=request.form['identifier13'],
                thumbnail=request.form['thumbnail'],
                previewlink=request.form['previewlink'],
                tanto=request.form['tanto'],
                hokan=request.form['hokan'],
                memo=request.form['memo'],
                )
        db.session.add(entry)
        db.session.commit()
        flash('書籍情報が登録されました', 'alert alert-info')
        return redirect(url_for('entry.show_entries'))
    except:
        flash('エラーが発生しました (同じタイトルの書籍がすでに登録されているかもしれません)', 'alert alert-danger')
        return redirect(url_for('entry.show_entries'))

@entry.route('/entries/get_isbn', methods=['POST'])
@login_required
def get_isbn():
    isbn = request.form['getisbn']
    url = 'https://www.googleapis.com/books/v1/volumes?q=isbn:'
    isbn_path = "./isbn_data/" + isbn + ".json"
    titlevalue = ""
    descriptionvalue = ""
    publishervalue = ""
    publisheddatevalue = ""
    identifier10value = ""
    identifier13value = ""
    thumbnailvalue = ""
    previewlinkvalue = ""
    try:
        with open(isbn_path, 'r') as f:
            data = json.load(f)
            try:
                titlevalue += data['items'][0]['volumeInfo']['title']
                try:
                    descriptionvalue += data['items'][0]['volumeInfo']['description']
                except:
                    # flash('概要を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publishervalue += data['items'][0]['volumeInfo']['authors'][0]
                except:
                    # flash('発行者を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publisheddatevalue += data['items'][0]['volumeInfo']['publishedDate']
                except:
                    # flash('発行日を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier'] == isbn:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-10を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier'] == isbn:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-13を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    thumbnailvalue += data['items'][0]['volumeInfo']['imageLinks']['thumbnail']
                except:
                    # flash('サムネイルを参照できませんでした', 'alert alert-danger')
                    thumbnailvalue += ""
                    # pass
                try:
                    previewlinkvalue += data['items'][0]['volumeInfo']['previewLink']
                except:
                    # flash('プレビューを参照できませんでした', 'alert alert-danger')
                    pass
                flash('書籍情報を参照しました', 'alert alert-info')
            except:
                flash('書籍情報を参照できませんでした', 'alert alert-danger')


    except:
        req_url = url + isbn
        response = requests.get(req_url)
        with open(isbn_path, 'w') as f:
            json.dump(response.json(), f)
        with open(isbn_path, 'r') as f:
            data = json.load(f)
            try:
                titlevalue += data['items'][0]['volumeInfo']['title']
                try:
                    descriptionvalue += data['items'][0]['volumeInfo']['description']
                except:
                    # flash('概要を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publishervalue += data['items'][0]['volumeInfo']['authors'][0]
                except:
                    # flash('発行者を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    publisheddatevalue += data['items'][0]['volumeInfo']['publishedDate']
                except:
                    # flash('発行日を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier'] == isbn:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier10value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-10を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    if data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier'] == isbn:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][1]['identifier']
                    else:
                        identifier13value += data['items'][0]['volumeInfo']['industryIdentifiers'][0]['identifier']
                except:
                    # flash('ISBN-13を参照できませんでした', 'alert alert-danger')
                    pass
                try:
                    thumbnailvalue += data['items'][0]['volumeInfo']['imageLinks']['thumbnail']
                except:
                    # flash('サムネイルを参照できませんでした', 'alert alert-danger')
                    thumbnailvalue += ""
                    # pass
                try:
                    previewlinkvalue += data['items'][0]['volumeInfo']['previewLink']
                except:
                    # flash('プレビューを参照できませんでした', 'alert alert-danger')
                    pass
                flash('書籍情報を参照しました', 'alert alert-info')
            except:
                flash('書籍情報を参照できませんでした', 'alert alert-danger')


    return render_template('entries/new.html',
        titlevalue=titlevalue,
        descriptionvalue=descriptionvalue,
        publishervalue=publishervalue,
        publisheddatevalue=publisheddatevalue,
        identifier10value=identifier10value,
        identifier13value=identifier13value,
        thumbnailvalue=thumbnailvalue,
        previewlinkvalue=previewlinkvalue)

@entry.route('/entries/new', methods=['GET'])
@login_required
def new_entry():
    return render_template('entries/new.html')

@entry.route('/entries/<int:id>', methods=['GET'])
@login_required
def show_entry(id):
    entry = Entry.query.get(id)
    return render_template('entries/show.html', entry=entry)


@entry.route('/entries/<int:id>/edit', methods=['GET'])
@login_required
def edit_entry(id):
    entry = Entry.query.get(id)
    return render_template('entries/edit.html', entry=entry)

flask_book/views/views.py
from flask import request, redirect, url_for, render_template, flash, session
from flask_book import app
from functools import wraps


def login_required(view):
    @wraps(view)
    def inner(*args, **kwargs):
        if not session.get('logged_in'):
            # return redirect(url_for('/'))
            return redirect(url_for('login'))
        return view(*args, **kwargs)
    return inner


@app.route('/login', methods=['GET', 'POST'])
def login():
    error = None
    if request.method == 'POST':
        if request.form['username'] != app.config['USERNAME']:
            flash('ユーザ名が異なります', 'alert alert-danger')
        elif request.form['password'] != app.config['PASSWORD']:
            flash('パスワードが異なります', 'alert alert-danger')
        else:
            session['logged_in'] = True
            # flash('ログインしました', 'alert alert-info')
            return redirect(url_for('entry.show_entries'))
    return render_template('login.html')


@app.route('/logout')
def logout():
    session.pop('logged_in', None)
    flash('ログアウトしました', 'alert alert-info')
    return redirect(url_for('entry.show_entries'))

@app.route('/readme')
def readme():
    return render_template('readme.html')

@app.errorhandler(404)
def non_existant_route(error):
   return redirect(url_for('login'))

flask_book/templates/layout.html
<!doctype html>
<title>書籍管理台帳</title>

<link rel="stylesheet" href="/static/bootstrap.min.css">
<!-- <link rel="stylesheet" href="https://bootswatch.com/4/spacelab/bootstrap.min.css"> -->
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
<link rel=stylesheet href="{{ url_for('static', filename='style.css') }}">
<meta name="viewport" content="width=device-width, initial-scale=1">

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.css">
<script type="text/javascript" charset="utf8" src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js"></script>

<script>
    $(document).ready( function () {
        $('#myTable').DataTable(
            {
                "language": {
                    "emptyTable" : "データが登録されていません。",
                    "info" : "_TOTAL_ 件中 _START_ 件から _END_ 件までを表示",
                    "infoEmpty" : "",
                    "infoFiltered" : "(_MAX_ 件からの絞り込み表示)",
                    "infoPostFix" : "",
                    "thousands" : ",",
                    "lengthMenu" : "表示件数: _MENU_",
                    "loadingRecords" : "ロード中",
                    "processing" : "処理中...",
                    "search" : "検索",
                    "zeroRecords" : "該当するデータが見つかりませんでした。",
                    "paginate" : {
                        "first" : "先頭",
                        "previous" : "前へ",
                        "next" : "次へ",
                        "last" : "末尾"
                    }
                }
            }
        );
    });
</script>


<nav class="navbar navbar-expand-lg navbar-dark bg-primary fixed-top">
    <a class="navbar-brand" href="/list">書籍管理台帳</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarColor01" aria-controls="navbarColor01" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarColor01">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item">
                <a class="nav-link" href="{{ url_for('readme') }}">使い方</a>
            </li>
            {% if not session.logged_in %}
            <li class="nav-item">
                <a class="nav-link" href="{{ url_for('login') }}">ログイン</a>
            </li>
            {% else %}
            <li class="nav-item">
                <a class="nav-link" href="{{ url_for('entry.new_entry') }}">新規登録</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="{{ url_for('logout') }}">ログアウト</a>
            </li>
            {% endif %}
        </ul>
        <form action="{{ url_for('entry.search_entries') }}" class="form-inline my-2 my-lg-0" method=post>
            <input class="form-control mr-sm-2" type="text" placeholder="Search" name=searchword>
            <button class="btn btn-secondary my-2 my-sm-0" type="submit">Search</button>
        </form>
    </div>
</nav>


{% for category, message in get_flashed_messages(with_categories=true) %}
<div class="{{ category }}" role="alert">
    {{ message }}
</div>
{% endfor %}

<div class="book-body container">
    <p>
        {% block body %}{% endblock %}
    </p>
</div>

flask_book/templates/login.html
{% extends "layout.html" %} {% block body %}

<form action="{{ url_for('login') }}" method=post>
    <fieldset>
        <div class="form-group col-sm-3">
            <label for="InputTitle">ノーツID</label>
            <input type="text" class="form-control" id="InputTitle" name=username placeholder="Lotus Notes ID">
            <!-- <small id="notesid" class="form-text text-muted">ノーツIDを入力</small> -->
        </div>
        <div class="form-group col-sm-3">
            <label for="InputPassword">パスワード</label>
            <input type="password" class="form-control" id="InputPassword" name=password placeholder="Password">
            <!-- <small id="notespassword" class="form-text text-muted">ノーツのパスワードを入力</small> -->
        </div>
        <div class="form-group col-sm-3">
            <button type="submit" class="btn btn-primary">ログイン</button>
        </div>
    </fieldset>
</form>
{% endblock %}

flask_book/templates/readme.html
{% extends "layout.html" %}


{% block body %}

<div class="form-group col-sm-9">
    <h3>概要</h3>
        <p>会社で購入した書籍について、書籍棚にあっても探しにくいので電子化しました。<br>
            購入した書籍は登録してみんなでシェアできるようにしたく、できるだけ登録してもらえると幸いです。<br>
            書籍情報は ISBNコードをもとに Google Books API から情報を取得して登録しやすくしています。<br>
            （Google が API を廃止したら破綻します。。。その時は楽天ブックスあたりから取得します。）
        </p>
    <h3>ログイン</h3>
        <p>ユーザ名およびパスワードはsysです。（LDAP認証したい！）</p>
    <h3>新規登録</h3>
        <p>書籍の裏面にあるバーコードのあたりにある 9784 から始まるコードを入力して、<br>
            「書籍参照」をクリックするとタイトルなどの情報を取得できます。<br>
            担当者・保管場所・メモは手入力してください。<br>
            参照後に「登録」をクリックして登録してください。<br>
            ※万が一、参照できない場合は手動入力してください。<br>
            ※新しい書籍は Google の情報が追いついて内容で参照できないことがあります。<br>
            ※同じタイトルの書籍が存在するときはエラーにしています。
        </p>
    <h3>閲覧</h3>
        <p>ページタイトルの「書籍管理台帳」をクリックすると一覧画面を表示できます。<br>
            書籍のサムネイルをクリックすると Google のプレビューを表示します。<br>
            ISBNコードをクリックすると Amazon の商品ページを表示します。
        </p>
    <h3>検索</h3>
        <p>Search ボックスから書籍情報や保管場所などの登録情報から文字列検索できます。<br>
            書籍の概要情報も検索対象にしています。<br>
            大文字小文字の区別はありません。
        </p>
    <h3>編集</h3>
        <p>一覧にてIDのリンクをクリックすると書籍情報を編集できます。<br>
            Google Books の最新情報を改めて取得して更新してください。<br>
            最新情報がまだ取得できない場合は手入力で更新してください。
        </p>
    <h3>削除</h3>
        <p>一覧にてIDのリンクをクリックすると書籍情報を削除ボタンにまで進めます。</p>
</div>


{% endblock %}